/*******************************************************************************
***  This file is part of Dux Rei Nummariae.                                 ***
***                                                                          ***
***  Copyright (C) 2017, 2018, 2019, 2020, 2021                              ***
***  John Schneiderman <Licensing _AT_ Schneiderman _DOT_ me>                ***
***                                                                          ***
***  This program is free software: you can redistribute it and/or modify it ***
***  under the terms of the GNU Affero General Public License as published   ***
***  by the Free Software Foundation, either version 3 of the License, or    ***
***  (at your option) any later version.                                     ***
***                                                                          ***
***  This program is distributed in the hope that it will be useful, but     ***
***  WITHOUT ANY WARRANTY; without even the implied warranty of              ***
***  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    ***
***  See the GNU Affero General Public License for more details.             ***
***                                                                          ***
***  You should have received a copy of the GNU Affero General Public License***
***  along with this program. If not, see <http://www.gnu.org/licenses/>.    ***
*******************************************************************************/
#ifndef DRN_FILE_STORAGE_TESTS_BUDGETFILECONTENTS_H_
#define DRN_FILE_STORAGE_TESTS_BUDGETFILECONTENTS_H_

#include <map>


class QString;

namespace drn
{
namespace accounting
{

class AccountCode;
class AccountNumber;
class GeneralLedger;

}
namespace banking
{

enum class SupportedAccountTypes;
struct BankMap;
class BankName;

}
namespace budgeting
{

class Budget;
class BudgetSource;

}
namespace foundation
{

template<typename, typename>
class TypeIndexMap;

}
namespace file_storage
{
namespace tests
{

QString unitTestDirectoryPath();
const char* validContents();
const char* validEmptyContents();
const char* validOpeningAccountNoTransactionsContents();
const budgeting::Budget& validBudget();
const accounting::GeneralLedger& validGeneralLedger();
const budgeting::Budget& validBudgetOpeningAccountNoTransactions();
const accounting::GeneralLedger& validGeneralLedgerOpeningAccountNoTransactions();
const banking::BankMap& validBanks();
const std::map<
	banking::BankName,
	std::map<accounting::AccountNumber, banking::SupportedAccountTypes>
>& validSupportedAccountTypes();
foundation::TypeIndexMap<budgeting::BudgetSource, accounting::AccountCode> validBudgetCodes();

}}}

#endif
