/*******************************************************************************
***  This file is part of Dux Rei Nummariae.                                 ***
***                                                                          ***
***  Copyright (C) 2017, 2018, 2019, 2020, 2021                              ***
***  John Schneiderman <Licensing _AT_ Schneiderman _DOT_ me>                ***
***                                                                          ***
***  This program is free software: you can redistribute it and/or modify it ***
***  under the terms of the GNU Affero General Public License as published   ***
***  by the Free Software Foundation, either version 3 of the License, or    ***
***  (at your option) any later version.                                     ***
***                                                                          ***
***  This program is distributed in the hope that it will be useful, but     ***
***  WITHOUT ANY WARRANTY; without even the implied warranty of              ***
***  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    ***
***  See the GNU Affero General Public License for more details.             ***
***                                                                          ***
***  You should have received a copy of the GNU Affero General Public License***
***  along with this program. If not, see <http://www.gnu.org/licenses/>.    ***
*******************************************************************************/
#include <QString>
using ::QString;
#include <QTest>
// using QCOMPARE

#include <stdexcept>
using std::runtime_error;

#include <foundation/Error.h>
using drn::foundation::Error;


namespace drn
{
namespace error_handling
{
namespace tests
{

struct ErrorUT : QObject
{
	Q_OBJECT

private slots:
	//{ Constructor Tests

	void constructor_MessageOnly_ShouldBeJustMessate()
	{
		const QString testMessage{"This is a test message."};
		const Error err{testMessage};
		QCOMPARE(err.what(), testMessage);
		QCOMPARE(err.message(), testMessage);
	}
	void constructor_FullInit_ShouldBeMessageAndBase()
	{
		const QString testMessage{"This is a test message."};
		const runtime_error rootError{"This is the root error message."};
		const Error err{testMessage, rootError};
		QCOMPARE(err.what(), (testMessage + " Caused By: " + rootError.what()));
		QCOMPARE(err.message(), testMessage);
	}

	//}
};

}}}

QTEST_MAIN(drn::error_handling::tests::ErrorUT)
#include "Error-unit-tests.moc"
