/*******************************************************************************
***  This file is part of Dux Rei Nummariae.                                 ***
***                                                                          ***
***  Copyright (C) 2017, 2018, 2019, 2020, 2021                              ***
***  John Schneiderman <Licensing _AT_ Schneiderman _DOT_ me>                ***
***                                                                          ***
***  This program is free software: you can redistribute it and/or modify it ***
***  under the terms of the GNU Affero General Public License as published   ***
***  by the Free Software Foundation, either version 3 of the License, or    ***
***  (at your option) any later version.                                     ***
***                                                                          ***
***  This program is distributed in the hope that it will be useful, but     ***
***  WITHOUT ANY WARRANTY; without even the implied warranty of              ***
***  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                    ***
***  See the GNU Affero General Public License for more details.             ***
***                                                                          ***
***  You should have received a copy of the GNU Affero General Public License***
***  along with this program. If not, see <http://www.gnu.org/licenses/>.    ***
*******************************************************************************/
#include <QTest>
// using QTEST_MAIN

#include <foundation/ScopeExecutor.h>
using drn::foundation::ScopeExecutor;


namespace drn
{
namespace foundation
{
namespace tests
{

struct ScopeExecutorUT : QObject
{
	Q_OBJECT

private slots:
	void constructor_ValidParam_ShouldExecute()
	{
		bool isExecuted{false};

		{
			ScopeExecutor _{
				[&isExecuted] () noexcept
				{
					isExecuted = true;
				}
			};
		}
		QVERIFY2(isExecuted, "The executor should have fired upon destruction.");
	}
};

}}}

QTEST_MAIN(drn::foundation::tests::ScopeExecutorUT)
#include "ScopeExecutor-unit-tests.moc"
